// C Source File
// Created 2/5/2004; 4:34:59 PM


#include <tigcclib.h>

#include "data.h"



INT_HANDLER save_int_1;
INT_HANDLER save_int_5;
INT_HANDLER save_int_3;
int Xman,Yman,Xcotton,Ycotton,score,i;
volatile int counter;
volatile int timer;
volatile int gameover;

unsigned char buffer[30];

/*custom timer*/
DEFINE_INT_HANDLER (my_int_handler){
		if(gameover==0&&--counter==0){
			counter=19;
			timer--;
			DispTimer();
			if(!timer)gameover=1;
		}
}
/*checks if "cotonhsc" is archived or locked*/
short isArchivedOrLocked(void) {
    SYM_ENTRY* symentry;
    if(!(symentry = DerefSym(SymFind($(cotonhsc)))))return 0;
    return (symentry->flags.bits.archived || symentry->flags.bits.locked);
}
/*NOT USED IN FINAL VERSION
short DoesItExist(void){
	SYM_ENTRY* symentry;
	
	if(!(symentry = DerefSym(SymFind("cotonhsc"))))return 1;

}*/

/*draws man*/
void DrawMan(void){
	Sprite8(Xman,Yman,8,Man,GetPlane(DARK_PLANE),SPRT_OR);
}
/*draws cotton*/
void DrawCotton(void){
	Sprite8(Xcotton,Ycotton,8,Cotton,GetPlane(DARK_PLANE),SPRT_OR);
}
/*generates new *random* cotton*/
void NewCotton(void){
	randomize();
	Xcotton=random(141)+1;
	Ycotton=random(81)+1;
}
/*checks for man/cotton collision*/
void CollideCheck(){
	if((abs(Xman-Xcotton))<=8&&(abs(Yman-Ycotton))<=8){
		score++;
		NewCotton();
		DispScore();
	}
}
/*turns off interupts and sets variables*/
void Setup(void){
	gameover=1;
	InteruptsOff();
	GrayOn();
	score=0;
	Xman=1;
	Yman=1;
	NewCotton();
	FontSetSys(F_6x8);
	memset(LCD_MEM,0x0,LCD_SIZE);
}
/*tests the arrow keys*/
void Keytest(void){
	if(_keytest(RR_RIGHT)&&Xman++==152)Xman=152;
	if(_keytest(RR_LEFT )&&Xman--==1  )Xman=1;
	if(_keytest(RR_DOWN )&&Yman++==82 )Yman=82;
	if(_keytest(RR_UP   )&&Yman--==1  )Yman=1;
	if(_keytest(RR_ESC  )             )Exit();
	for(i=0;i<1000;i++)if(!counter)break;
}
/*turns off the interupts and sets custom interupt*/
void InteruptsOff(void){
	GrayOff();
	save_int_1 = GetIntVec (AUTO_INT_1);
	save_int_5 = GetIntVec (AUTO_INT_5);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
	SetIntVec (AUTO_INT_5, my_int_handler);
}
/*resets inerupts*/
void InteruptsOn(void){
	SetIntVec (AUTO_INT_1, save_int_1);
	SetIntVec (AUTO_INT_5, save_int_5);
}
/*clears the screen*/
void Clear_Part_Screen(void){
	memset(GetPlane(DARK_PLANE),0x0,2730);
}
/*waits for timer while delaying between key presses*/
void Pause(void){
	while(counter);
}
/*displays score on bottom*/
void DispScore(void){
	sprintf(buffer,"%d",score);
	DrawStr(140,93,buffer,A_REPLACE);
}
/*displays timer on bottom*/
void DispTimer(void){
	DrawStr(106,93,"    ",A_REPLACE);
	sprintf(buffer,"%d",timer);
	DrawStr(106,93,buffer,A_REPLACE);
}
/*disp "cotton picker" on bottom*/
void DispBottomText(void){
	memset(GetPlane(LIGHT_PLANE)+2760,0x0,240);
	memset(GetPlane(DARK_PLANE)+2760,0x0,240);
	DrawStr(0,92,"Cotton Picker|",A_NORMAL);
	DrawStr(112,92,"|",A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr(82,93,"Timer-30",A_NORMAL);
	DrawStr(116,93,"Score-0",A_NORMAL);
}
/*test if the timer expired*/
void TestTimerExpire(void){
	if(timer==0)GameOver();
}
void GameOver(void){
	HighscoreCheck();
}
void Exit(void){
	GrayOff();
	InteruptsOn();
	GKeyFlush();
	exit(0);
}
/*displays intro screen*/
void Intro(void){
	int x;
	char score[5];
	char name[40];
	FILE *file;
	file=NULL;
	for(x=0;x<100;x++){
		memcpy(GetPlane(LIGHT_PLANE)+(x*30),IntroLight+(x*20),20);
		memcpy(GetPlane(DARK_PLANE)+(x*30),IntroDark+(x*20),20);
	}
	FontSetSys(F_4x6);
	DrawStr(36,95,"Created By: jmank88@sbcglobal.net",A_NORMAL);

	//loads current highscore, and displays it
	//***********************
	file = fopen("cotonHSC","rb");
	if((file!=NULL)&&(!isArchivedOrLocked())){
		fgetc(file);
		sprintf(score,"%d",fgetc(file));
		fgets(name,10,file);
	}
	else{
	sprintf(score,"%d",0);
	sprintf(name,"");
	}
	fclose(file);
	
	FontSetSys(F_6x8);
	DrawStr(0,72,"Highscore:",A_REVERSE);
	DrawStr(0,82,name,A_NORMAL);
	DrawStr(0,92,score,A_NORMAL);
	//***********************
	
	
	while(_rowread(0));
	while(!_rowread(0));
}
void HighscoreCheck(void);


/***Main Function*********/
void _main(void)
{
while(1){
	Setup();
	Intro();
	DispBottomText();
	DrawMan();
	DrawCotton();
	gameover=0;
	counter=19;
	timer=30;
	while(1){
			//do{
				if(gameover)break;
			//}while(!_rowread(0));
			Keytest();
			Clear_Part_Screen();
			DrawMan();
			DrawCotton();
			CollideCheck();
			DispScore();
	}
	GameOver();
}
}
/*end of main*/

/*******************************************/
/* checks for highscore file, then checks  */
/* for new highscore, and modifies/creates */
/* highscore file accordingly              */
/*******************************************/
void HighscoreCheck(void){
	FILE *file1;
	
	GrayOff();
	InteruptsOn();
	
	FontSetSys(F_6x8);
	clrscr();
	file1=NULL;
	if(isArchivedOrLocked()){
		printf("Error: cotonhsc is archived or locked");
		while(_rowread(0));
		while(!_rowread(0));
	}
	else{
		file1 = fopen("cotonHSC","r+b");
		if(file1==NULL){
			fclose(file1);
			file1 = fopen ("cotonHSC", "wb");//try to open HSC file
			fputc (0,file1);
			fputc (score, file1);
			printf("New High Score!\n%d\nEnter Your Name-",score);
			fputs (getsn(buffer,10),file1);
			fputc (0, file1);
			fputs ("HSC", file1);
			fputc (0, file1);
			fputc (OTH_TAG, file1);
			fclose (file1);
		}
		else{
			fgetc(file1);
			if(score>fgetc(file1)){
				fclose(file1);
				file1 = fopen ("cotonHSC", "wb");
				fputc(0,file1);
				fputc(score, file1);
				printf("New High Score!\n%d\nEnter Your Name-",score);
				fputs (getsn(buffer,10),file1);
				fputc (0, file1);
				fputs ("HSC", file1);
				fputc (0, file1);
				fputc (OTH_TAG, file1);
			}
			else{
				printf("You Lose");
				while(_rowread(0));
				while(!_rowread(0));
			}
			fclose(file1);
		}
	}
}